# zoo - versatile objects management
# Copyright (C) 2016  Entr'ouvert
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.urls import re_path, include
from django.contrib import admin

from .views import login, logout

urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^demo/', include('zoo.zoo_demo.urls')),
    re_path(r'^rsu/', include('zoo.zoo_nanterre.urls')),
    re_path(r'^logout/$', logout, name='logout'),
    re_path(r'^login/$', login, name='auth_login'),
]
